unit uScaledOnly;
{ ============================================================================= }
{                               UNIT uScaledOnly                                }
{ Description: This is a demonstration of scaling a height data source image    }
{ by a factor of 2. This can be useful if you want trick Glscene into giving you}
{ a tilesize of 1 instead of 8 ie just make the scale 8!                        }
{                                                                               }
{ Created May 2004 Skinhat                                                      }
{ ============================================================================= }
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLTexture, GLScene, GLTerrainRenderer, GLWin32Viewer, GLMisc,jpeg,
  GLHeightData, GLObjects,vectorgeometry, GLCadencer, StdCtrls,
  GLHeightTileFileHDS, uScaledBitmapHDS;

type
  TForm1 = class(TForm)
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLCamera: TGLCamera;
    GLTerrainRenderer1: TGLTerrainRenderer;
    GLMaterialLibrary1: TGLMaterialLibrary;
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    GLScaledBitmapHDS:TGLScaledBitmapHDS;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormActivate(Sender: TObject);
begin
  GLScaledBitmapHDS:=TGLScaledBitmapHDS.create(nil);
  GLScaledBitmapHDS.scale:=2;
  GLScaledBitmapHDS.Picture.LoadFromFile('..\media\elevation256x256mirror.bmp');
  GLScaledBitmapHDS.InfiniteWrap:=false;
  GLTerrainRenderer1.HeightDataSource:=GLScaledBitmapHDS;

  glcamera.position.y:=glterrainrenderer1.InterpolatedHeight(glcamera.position.asvector);

end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  factor:double;
  i:integer;
begin
  if (ssshift in shift) then
    factor:=4
  else
    factor:=2;
  case key of
    35,40: glcamera.move(-0.5*factor);
    37: begin
        glcamera.turn(-5*factor);

      end;
    39: begin
        glcamera.turn(5*factor);

      end;
    38,65,16: glcamera.move(0.5*factor);
    33:  glcamera.pitch(2*factor);
    34:  glcamera.pitch(-1*factor);

  end;

  glcamera.position.z:=1+glterrainrenderer1.InterpolatedHeight(glcamera.position.asvector);
  caption:=format('x%0.2f y%0.2f z%0.2f',[glcamera.position.x,glcamera.position.y,glcamera.position.z]);
end;


end.
