unit uTwoImages;
{ ============================================================================= }
{                              UNIT TwoImages                                   }
{ Description : This demonstrates the multibitmaphds. Generates a terrain from  }
{ two greyscale images, both of which are 256x256. The second one is move across}
{ by 256 so the two height datasources produce two terrains side by side.       }
{                                                                               }
{ Created May 2004 Skinhat                                                      }
{ ============================================================================= }
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLTexture, GLScene, GLTerrainRenderer, GLWin32Viewer, GLMisc,jpeg,
  GLHeightData, GLObjects,vectorgeometry, GLCadencer, StdCtrls,
  GLHeightTileFileHDS, nvMultiBitmapHDS;

type
  TForm1 = class(TForm)
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLCamera: TGLCamera;
    GLTerrainRenderer1: TGLTerrainRenderer;
    GLMaterialLibrary1: TGLMaterialLibrary;
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    GLMultiBitmapHDS:TGLMultiBitmapHDS;
    GLBitmapHDS:TGLBitmapHDS;
    ElevationMaps:TElevationMaps;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormActivate(Sender: TObject);
var
  elevationMap:TElevationMap;
begin

  ElevationMaps:=TElevationMaps.create;
  elevationMap:=ElevationMaps.add;
  elevationMap.picture.bitmap.loadfromfile('../media/elevation256x256mirror.bmp');
  elevationMap:=ElevationMaps.add;
  elevationMap.picture.bitmap.loadfromfile('../media/lindos256x256.bmp');
  elevationMap.x:=256;
  GLMultiBitmapHDS:=TGLMultiBitmapHDS.create(ElevationMaps);
  GLTerrainRenderer1.HeightDataSource:=GLMultiBitmapHDS;
  glcamera.position.y:=glterrainrenderer1.InterpolatedHeight(glcamera.position.asvector);

end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  factor:double;
  i:integer;
begin
  if (ssshift in shift) then
    factor:=4
  else
    factor:=2;
  case key of
    35,40: glcamera.move(-0.5*factor);
    37: begin
        glcamera.turn(-5*factor);

      end;
    39: begin
        glcamera.turn(5*factor);

      end;
    38,65,16: glcamera.move(0.5*factor);
    33:  glcamera.pitch(2*factor);
    34:  glcamera.pitch(-1*factor);

  end;

  glcamera.position.z:=1+glterrainrenderer1.InterpolatedHeight(glcamera.position.asvector);
  caption:=format('x%0.2f y%0.2f z%0.2f',[glcamera.position.x,glcamera.position.y,glcamera.position.z]);
end;


end.
